#include "DPInput.h"

LPDIRECTINPUT8 lpdi;
DPInput *ginput;

DPInput::DPInput(HWND hwnd, HINSTANCE hinst)
{
	ginput=this;
	
	DirectInput8Create(hinst, DIRECTINPUT_VERSION, IID_IDirectInput8, (void**)&lpdi, NULL);
	// Init keyboard
	lpdi->CreateDevice(GUID_SysKeyboard, &lpdiKeyboard, NULL);
	lpdiKeyboard->SetCooperativeLevel(hwnd, DISCL_NONEXCLUSIVE|DISCL_FOREGROUND);
	lpdiKeyboard->SetDataFormat(&c_dfDIKeyboard);
	lpdiKeyboard->Acquire();
};

DPInput::~DPInput()
{
	lpdiKeyboard->Unacquire();
	lpdiKeyboard->Release();
	lpdi->Release();
};

void DPInput::Reacquire() // Call regularly in case the device is lost
{
	lpdiKeyboard->Acquire();
};

void DPInput::Update()
{
	if(lpdiKeyboard->GetDeviceState(256, (LPVOID)&diKeys)!=DI_OK)
	{
		lpdiKeyboard->Acquire();
		// Mark all keys as released if state could not be retrieved
		for(int i=0;i<256;i++)
			diKeys[i]=0x00;
	}
};

bool DPInput::KeyPressed(int key)
{
	if(diKeys[key]&0x80)
		return true;
	return false;
};


